From 175f521bc2d5cc370b16f12efd8c72578212220b Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 22 2017 17:21:45 +0000
Subject: [PATCH 760/1001] The add_widget panel is only used to choose the widget name


Then it delegates the configuration to the widget's add_url.

---

diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index a682d85..dc3da86 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -350,7 +350,7 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/ralph/add/about?position=right'
             result = self.app.get(url)
-            self.assertIn('Adding widget "about" to hub: ralph',
+            self.assertIn('Adding widget "about" to hub ralph',
                           result.get_data(as_text=True))
 
     def test_hub_add_widget_invalid_side(self):
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index a0247f4..a4a8b19 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -139,96 +139,3 @@ def hub_edit_post(name):
             return ('ok', 200)
     else:
         return flask.redirect(flask.url_for('hub', name=name))
-
-
-@app.route('/<name>/add/', methods=['GET', 'POST'])
-@app.route('/<name>/add', methods=['GET', 'POST'])
-def hub_add_widgets(name):
-    if flask.request.method == 'POST':
-        return hub_add_widget_post(name)
-    else:
-        return hub_add_widget_get(name)
-
-
-@app.route('/<name>/add/<widget_name>/', methods=['GET'])
-@app.route('/<name>/add/<widget_name>', methods=['GET'])
-def hub_add_widget(name, widget_name):
-    hub = get_hub(name)
-    side = str(flask.request.args.get('position')).lower()
-    if side not in ['right', 'left']:
-        flask.abort(400, 'Invalid position provided')
-
-    widget = hubs.widgets.registry[widget_name]
-    if widget.position not in ['both', side]:
-        flask.abort(400, "This widget can't be placed here")
-
-    return flask.render_template(
-        'add_widget.html',
-        hub=hub,
-        widget=widget,
-        side=side,
-        url_to=flask.url_for('hub_add_widgets', name=name),
-    )
-
-
-def hub_add_widget_get(name):
-    hub = get_hub(name)
-    side = str(flask.request.args.get('position')).lower()
-    if side not in ['right', 'left']:
-        flask.abort(400, 'Invalid position provided')
-
-    widgets = [
-        widget
-        for widget in hubs.widgets.registry
-        if hubs.widgets.registry[widget].position in ['both', side]
-        ]
-    return flask.render_template(
-        'add_widget.html',
-        hub=hub,
-        widgets=widgets,
-        side=side,
-    )
-
-
-def hub_add_widget_post(name):
-    widget_name = flask.request.form.get('widget_name')
-    position = flask.request.form.get('position', '').lower()
-    if not widget_name:
-        flask.abort(400, 'Invalid request sent')
-    if widget_name not in hubs.widgets.registry:
-        flask.abort(404, 'Unknown widget called')
-
-    hub = get_hub(name)
-
-    widget = widget = hubs.models.Widget(
-        plugin=widget_name, index=-1, left=position == 'left')
-    error = False
-    config = {}
-    for param in widget.module.get_parameters():
-        val = flask.request.form.get(param.name)
-        if not val:
-            flask.flash(
-                'You must provide a value for: %s' % param.name, 'error')
-            error = True
-            break
-        try:
-            val = param.validator.from_string(val)
-            config[param.name] = val
-        except Exception as err:
-            flask.flash('Invalid data provided, error: %s' % err, 'error')
-            error = True
-    if not error:
-        widget.hub = hub
-        widget.config = config
-        try:
-            flask.g.db.add(widget)
-            flask.g.db.flush()
-            widget.hub.last_edited = datetime.datetime.utcnow()
-            flask.g.db.commit()
-        except Exception as err:
-            print(err)
-            flask.flash(
-                'Could not save the configuration to the database '
-                'if the error persists, please warn an admin',
-                'error')
-    return flask.redirect(flask.url_for('hub_edit', name=hub.name))
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 60b1326..02c06c8 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -19,6 +19,40 @@ def widget_json(hub, idx):
     return response
 
 
+@app.route('/<name>/add', methods=['GET', 'POST'])
+def hub_add_widget(name):
+    hub = get_hub(name)
+    position = flask.request.values.get('position', '')
+    if position not in ['right', 'left']:
+        flask.abort(400, 'Invalid position provided')
+    widgets = [
+        widget
+        for widget in registry
+        if registry[widget].position in ['both', position]
+        ]
+
+    if flask.request.method == 'POST':
+        widget_name = flask.request.form.get('widget')
+        if not widget_name:
+            flask.abort(400, 'Invalid request sent')
+        if widget_name not in widgets:
+            flask.abort(404, 'Unknown widget called')
+        widget = registry[widget_name]
+        if widget.get_parameters():
+            return flask.jsonify({
+                "status": "CONFIGURE",
+                "url": widget.get_add_url(hub, position),
+                })
+        create_widget_instance(hub, widget, position)
+        return flask.jsonify({"status": "ADDED"})
+    return flask.render_template(
+        'add_widget.html',
+        hub=hub,
+        widgets=widgets,
+        position=position,
+    )
+
+
 @app.route('/<hub>/add/<widget>', methods=['GET', 'POST'])
 def widget_add(hub, widget):
     hub = get_hub(hub)

